hdu1518 Square

题目链接:

http://acm.hdu.edu.cn/showproblem.php?pid=1518

题目为:

Square

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 7839    Accepted Submission(s): 2526

Problem Description

Given a set of sticks of various lengths, is it possible to join them end-to-end to form a square?

Input

The first line of input contains N, the number of test cases. Each test case begins with an integer 4 <= M <= 20, the number of sticks. M integers follow; each gives the length of a stick - an integer between 1 and 10,000.

Output

For each case, output a line containing "yes" if is is possible to form a square; otherwise output "no".

Sample Input

3
4 1 1 1 1
5 10 20 30 40 50
8 1 7 2 6 4 4 3 5

Sample Output

yes
no
yes

Source

University of Waterloo Local Contest 2002.09.21

Recommend

LL   |   We have carefully selected several similar problems for you:  1732 1401 1043 1226 1180

这个题目是搜索+剪枝优化..分析如下:

这个是给很多条棒子,然后看用某些棒子能拼成一个正方形。。

我的思路是如果搜索到4组,那么说明可以拼成一根木棒。。

剪枝的地方是:

1:如果有4组,那么久不要再搜索了。

2:为了避免重复,所以用了w这个变量。。。

代码为:

#include<cstdio>
#include<cstring>
#include<iostream>
#include<algorithm>
using namespace std;
const int maxn=20+10;
int a[maxn],vis[maxn];
int edge,average;
int t,sum,flag;
int m;
void dfs(int pos,int w,int count)
{
    if(pos==average)
    {
        count++;
        pos=0;
        w=1;
        if(count==4)
        {
            flag=1;
            return;
        }
    }
    if(flag)
        return;
    for(int i=w;i<=m;i++)
    {
       if(vis[i])
         continue;
       else
       {
           if(pos+a[i]<=average)
           {
               vis[i]=1;
               dfs(pos+a[i],i+1,count);
               vis[i]=0;
           }
       }
    }

}

int main()
{
    scanf("%d",&t);
    while(t--)
    {
        memset(vis,0,sizeof(vis));
        flag=0;
        sum=0;
        scanf("%d",&m);
        for(int j=1;j<=m;j++)
        {
            scanf("%d",&a[j]);
            sum=sum+a[j];
        }
        average=sum/4;
        flag=0;
        if(sum%4!=0||m<4||a[m]>sum/4)
            printf("no\n");
        else
        {
            dfs(0,1,0);
            if(flag)
                printf("yes\n");
            else
                printf("no\n");
        }
    }
    return 0;
}

hdu1518 Square

时间: 2024-10-26 22:47:10

hdu1518 Square的相关文章

HDU1518:Square(DFS)

Square Time Limit : 10000/5000ms (Java/Other)   Memory Limit : 65536/32768K (Java/Other) Total Submission(s) : 88   Accepted Submission(s) : 37 Font: Times New Roman | Verdana | Georgia Font Size: ← → Problem Description Given a set of sticks of vari

HDU1518 Square 【剪枝】

Square Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 8900    Accepted Submission(s): 2893 Problem Description Given a set of sticks of various lengths, is it possible to join them end-to-end

HDU1518 Square(DFS)

Square Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 11151    Accepted Submission(s): 3588 Problem Description Given a set of sticks of various lengths, is it possible to join them end-to-en

hdu1518(Square)深搜+剪枝

点击打开杭电1518 Problem Description Given a set of sticks of various lengths, is it possible to join them end-to-end to form a square? Input The first line of input contains N, the number of test cases. Each test case begins with an integer 4 <= M <= 20,

[leetcode] 367. Valid Perfect Square

Given a positive integer num, write a function which returns True if num is a perfect square else False. Note: Do not use any built-in library function such as sqrt. Example 1: Input: 16 Returns: True Example 2: Input: 14 Returns: False 使用二分查找寻找input

Project Euler 92:Square digit chains C++

A number chain is created by continuously adding the square of the digits in a number to form a new number until it has been seen before. For example, 44 → 32 → 13 → 10 → 1 → 1 85 → 89 → 145 → 42 → 20 → 4 → 16 → 37 → 58 → 89 Therefore any chain that

LeetCode Maximal Square

Given a 2D binary matrix filled with 0's and 1's, find the largest square containing all 1's and return its area. For example, given the following matrix: 1 0 1 0 0 1 0 1 1 1 1 1 1 1 1 1 0 0 1 0 Return 4. 思路分析:这题考察DP.缓存中间结果降低反复计算.DP方程为 if(matrix[i][j

Theatre Square 题解代码

Theatre Square CodeForces - 1A 水题水题... 最开始的程序是这个,可是AC不了我也不知道为什么......QAQ... #include <stdio.h>#include<stdlib.h>int main(){    int m,n,a,ans,tmp,k,h,tep,i,j;    scanf("%d %d %d",&m,&n,&a);    if(m%a==0)    {        if(n%a

[LeetCode] Matchsticks to Square 火柴棍组成正方形

Remember the story of Little Match Girl? By now, you know exactly what matchsticks the little match girl has, please find out a way you can make one square by using up all those matchsticks. You should not break any stick, but you can link them up, a